/**
 * Copyright 9re ( http://wonderfl.net/user/9re )
 * MIT License ( http://www.opensource.org/licenses/mit-license.php )
 * Downloaded from: http://wonderfl.net/c/qn4E
 */

// forked from keim_at_Si's クラリネットメソッド
// forked from bkzen's 【問題】Graphics の drawCircle と drawRoundRect が壊れました
//
// ドが壊れれば，レとミとファとソとラとシも壊れるものです．
// 【壊れ物リスト】
// - Number, Math 一式
// - var
// - 乗算/除算
// - 比較演算子
// - ループ関数
package 
{
	import flash.display.Graphics;
	import flash.display.Sprite;
	import flash.events.Event;
	
	/**
	 * Graphics.drawCircle と drawRoundRect が壊れました。
	 * 別の方法で、半径 CIRCLE_RADIUS の 円を書きなさい。
	 * @mxmlc -o bin/CircleTest.swf -load-config+=obj\Alltest3Config.xml
	 * @author jc at bk-zen.com
	 */
	public class CircleTest extends Sprite
	{
		private const ANSWER_COLOR: uint = 0x003366;
		private const COLOR: uint = 0x3399CC;
		private const CIRCLE_RADIUS: Number = 50;
		
		public function CircleTest() 
		{
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e: Event = null): void 
		{
			removeEventListener(Event.ADDED_TO_STAGE, init);
			//
			var centerX: Number = (stage.stageWidth - CIRCLE_RADIUS) / 2;
			var centerY: Number = (stage.stageHeight - CIRCLE_RADIUS) / 2;
			var g: Graphics = graphics;
			// 差を見るために解答として先に半径+1 の円を描いておきます。
			g.beginFill(ANSWER_COLOR); g.drawCircle(centerX, centerY, CIRCLE_RADIUS + 1);
			
			// 
			drawCircle(g, centerX, centerY, CIRCLE_RADIUS, COLOR);
		}
		
		/**
		 * これを作る。
		 * @param	g
		 * @param	x
		 * @param	y
		 * @param	r
		 * @param	color
		 */
		public function drawCircle(g: Graphics, x: Number, y: Number, r: Number, color: uint): void
		{
			function m(o:int, i:int, r:int=0) : int {
				return i?m(o<<1,i>>1,r+(o&(~((i&1)-1)))):r;
			}
			
			function d(o:int, i:int, r:int=0, t:int=17) : int { 
				return t?d(o-(i-o-1>>>31?i:0),i>>1,(r+(i-o-1>>>31))<<1,t-1):r>>1;
			}
			
			function s(o:int, i:int=1, r:int=0) : int { 
				return (r-o>>>31)?s(o,i+2,r+i):_s(o<<8,i<<8)>>8;
			}
			
			function _s(o:int, n:int, i:int=8) : int {
				return i?_s(o,n+d(o,n<<8)>>1,i-1):n;
			}
			
			function render(i:int, t:int=1) : int {
			    g.lineStyle(1, i << 18);
				g.moveTo(x-i, y-t+1);
				g.lineTo(x+i, y-t+1);
				g.moveTo(x-i, y+t-1);
				g.lineTo(x+i, y+t-1);
				return (r-t>>>31)?0:render(s(-m(t,t,-m(r,r))),t+1);
			}
			
			//g.lineStyle(1, color);
			render(r);
		}
		
	}

}